<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "idp_provision_verb".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "IdpProvisionVerb".
 *
 * Columns in table "idp_provision_verb" available as properties of the model,
 * followed by relations of table "idp_provision_verb" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idp_provision_id
 * @property string $entity
 * @property string $verb
 * @property string $date_added
 * @property string $date_updated
 *
 * @property IdpProvisionOperation[] $idpProvisionOperations
 * @property IdpProvision $idpProvision
 */
abstract class BaseIdpProvisionVerb extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'idp_provision_verb';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'IdpProvisionVerb|IdpProvisionVerbs', $n);
    }

    public static function representingColumn()
    {
        return 'entity';
    }

    public function rules()
    {
        return array(
            array('idp_provision_id, entity, verb, date_updated', 'required'),
            array('idp_provision_id', 'numerical', 'integerOnly'=>true),
            array('entity', 'length', 'max'=>45),
            array('verb', 'length', 'max'=>6),
            array('date_added', 'safe'),
            array('date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idp_provision_id, entity, verb, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'idpProvisionOperations' => array(self::HAS_MANY, 'IdpProvisionOperation', 'idp_provision_verb_id'),
            'idpProvision' => array(self::BELONGS_TO, 'IdpProvision', 'idp_provision_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'idp_provision_id' => null,
            'entity' => Yii::t('app', 'Entity'),
            'verb' => Yii::t('app', 'Verb'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'idpProvisionOperations' => null,
            'idpProvision' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idp_provision_id', $this->idp_provision_id);
        $criteria->compare('entity', $this->entity, true);
        $criteria->compare('verb', $this->verb, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
